function calcolopi(N)
% propagazione errori di arrotondamento
% istruzione di chiamata: calcolopi(N)
% Input: N 0 numero di elementi della succ. da calcolare
% Output: solo grafico

% costruisco il vettore con i valori della succ. f_n
f=zeros(N,1);
f(2)=2;
for n=2:N-1
  f(n+1)=2^(n-0.5)*sqrt(1-sqrt(1-4^(1-n)*f(n)^2));
end

% costruisco il vettore degli errori
e=abs(f-pi)/pi;

% disegno la succ f_n
figure(1);clf
plot((2:N)',f(2:N),'bo','MarkerFaceColor','b')
grid on
hold on
plot([2,N],[pi,pi],'k--')
xlabel('n')
ylabel('f_n')

% disegno gli errori
figure(2);clf
semilogy((2:N)',e(2:N),'ro','MarkerFaceColor','r')
grid on
xlabel('n')
ylabel('e_n')


